use std::env;
use std::fmt;
use std::mem;
use std::ptr;
extern crate rand;
struct Point<T> {
    x : T,
    y : T
}
impl fmt::Display for Point<i64> {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(f, "{}, {}", self.x, self.y)
    }
}

fn main(){
    let mut max : i32 = 0;
    let mut counter = 0;
    for argument in env::args() {
        if counter == 1 {
            max = argument.parse::<i32>().ok().expect("Wanted a number");
        }
        counter = counter + 1;
    }
    let mut items = allocate(max);
    //items = sort(items);    
    println!("{}", average(items));
}

fn allocate(max : i32) -> Vec<Point<i64>> {
   let mut points = Vec::with_capacity(max as usize);
   //let mut points = Vec::new();
    let mut ctr : i32 = 0;
    while ctr < max {
         points.push(Point{x : rand::random::<i64>(), y : rand::random::<i64>()});
         ctr += 1
    }
    return points
}

fn unsafe_allocate(max : i32) -> Vec<Point<i64>> {
    let mut points = Vec::with_capacity(max as usize);
    let pointer = points.as_mut_ptr();
    unsafe {
        mem::forget(points);
         // Overwrite memory with 4, 5, 6
        for i in 0..max as isize {
            let point = Point{x : rand::random::<i64>(), y : rand::random::<i64>()};
            ptr::write(pointer.offset(i), point);
        }
        points = Vec::from_raw_parts(pointer, max as usize, max as usize);
    }
    return points
}


fn sort(mut points : Vec<Point<i64>>) -> Vec<Point<i64>>{
    points.sort_by(|p1, p2| (p1.x + p1.y).cmp(&(p2.x + p2.y)));
    return points
}

fn average(points : Vec<Point<i64>>) -> Point<i64> {
    let mut avg = Point{x: 0i64, y: 0i64};
    let length = points.len() as i64;
    for p in points {
        avg.x = avg.x + p.x;    
        avg.y = avg.y + p.y;
    }
    avg.x = avg.x / length;
    avg.y = avg.y / length;
    return avg
}